#include "src/core/hotkeys.hpp"

#include <Qt>

const char *const Hotkeys::ConfigNames[(ubyte)Hotkey::NUM_HOTKEYS] = {
	/* AnalogUp,           */ "input_player1_l_y_minus",
	/* AnalogDown,         */ "input_player1_l_y_plus",
	/* AnalogLeft,         */ "input_player1_l_x_minus",
	/* AnalogRight,        */ "input_player1_l_x_plus",
	/* CUp,                */ "input_player1_r_y_minus",
	/* CDown,              */ "input_player1_r_y_plus",
	/* CLeft,              */ "input_player1_r_x_minus",
	/* CRight,             */ "input_player1_r_x_plus",
	/* DPadUp,             */ "input_player1_up",
	/* DPadDown,           */ "input_player1_down",
	/* DPadLeft,           */ "input_player1_left",
	/* DPadRight,          */ "input_player1_right",
	/* ButtonA,            */ "input_player1_b",
	/* ButtonB,            */ "input_player1_y",
	/* TriggerL,           */ "input_player1_l",
	/* TriggerZ,           */ "input_player1_l2",
	/* TriggerR,           */ "input_player1_r",
	/* Start,              */ "input_player1_start",
	/* SaveState,          */ "input_save_state",
	/* LoadState,          */ "input_load_state",
	/* PrevState,          */ "input_state_slot_decrease",
	/* NextState,          */ "input_state_slot_increase",
	/* PrevCheat,          */ "input_cheat_index_minus",
	/* NextCheat,          */ "input_cheat_index_plus",
	/* ToggleCheat,        */ "input_cheat_toggle",
	/* ToggleFps,          */ "input_fps_toggle",
	/* Pause,              */ "input_pause_toggle",
	/* FrameAdvance,       */ "input_frame_advance",
	/* FastForward,        */ "input_hold_fast_forward",
	/* ToggleFastForward,  */ "input_toggle_fast_forward",
	/* SlowMotion,         */ "input_hold_slowmotion",
	/* ToggleSlowMotion,   */ "input_toggle_slowmotion",
	/* Rewind,             */ "input_rewind",
	/* Quit,               */ "input_exit_emulator",
	/* HardReset,          */ "input_reset",
	/* ToggleFullscreen,   */ "input_toggle_fullscreen",
	/* RetroMenu,          */ "input_menu_toggle",
	/* RecordVideo,        */ "input_movie_record_toggle",
	/* RecordInputs,       */ "input_recording_toggle",
	/* Screenshot,         */ "input_screenshot",
	/* VolumeUp,           */ "input_volume_up",
	/* VolumeDown,         */ "input_volume_down",
	/* Mute                */ "input_audio_mute"
};


const int Hotkeys::Default[(ubyte)Hotkey::NUM_HOTKEYS] = {
		/* AnalogUp,           */ Qt::Key_W,
		/* AnalogDown,         */ Qt::Key_S,
		/* AnalogLeft,         */ Qt::Key_A,
		/* AnalogRight,        */ Qt::Key_D,
		/* CUp,                */ Qt::Key_Up,
		/* CDown,              */ Qt::Key_Down,
		/* CLeft,              */ Qt::Key_Left,
		/* CRight,             */ Qt::Key_Right,
		/* DPadUp,             */ Qt::KeypadModifier | Qt::Key_8,
		/* DPadDown,           */ Qt::KeypadModifier | Qt::Key_5,
		/* DPadLeft,           */ Qt::KeypadModifier | Qt::Key_4,
		/* DPadRight,          */ Qt::KeypadModifier | Qt::Key_6,
		/* ButtonA,            */ Qt::Key_Space,
		/* ButtonB,            */ Qt::Key_Shift,
		/* TriggerL,           */ Qt::Key_E,
		/* TriggerZ,           */ Qt::Key_Tab,
		/* TriggerR,           */ Qt::KeypadModifier | Qt::Key_0,
		/* Start,              */ Qt::Key_Return,
		/* SaveState,          */ Qt::Key_F2,
		/* LoadState,          */ Qt::Key_F4,
		/* PrevState,          */ Qt::Key_F6,
		/* NextState,          */ Qt::Key_F7,
		/* PrevCheat,          */ 0,
		/* NextCheat,          */ 0,
		/* ToggleCheat,        */ 0,
		/* ToggleFps,          */ Qt::Key_F3,
		/* Pause,              */ Qt::Key_P,
		/* FrameAdvance,       */ Qt::Key_K,
		/* FastForward,        */ Qt::Key_BracketRight,
		/* ToggleFastForward,  */ Qt::Key_Backslash,
		/* SlowMotion,         */ Qt::Key_BracketLeft,
		/* ToggleSlowMotion,   */ Qt::Key_Apostrophe,
		/* Rewind,             */ Qt::Key_Backspace,
		/* Quit,               */ Qt::Key_Escape,
		/* HardReset,          */ Qt::Key_QuoteLeft,
		/* ToggleFullscreen,   */ Qt::Key_F11,
		/* RetroMenu,          */ Qt::Key_F1,
		/* RecordVideo,        */ Qt::KeypadModifier | Qt::Key_Asterisk,
		/* RecordInputs,       */ 0,
		/* Screenshot,         */ Qt::Key_F12,
		/* VolumeUp,           */ Qt::Key_Minus,
		/* VolumeDown,         */ Qt::Key_Plus,
		/* Mute                */ Qt::Key_Equal
};
